<script setup lang="ts">
import { withDefaults, ref, onMounted } from 'vue';
import SdgBalloon from './SdgBalloon.vue';
import SdgFireworks from './SdgFireworks.vue';
import SdgRotationOne from './SdgRotationOne.vue';
import EffectsBubbles from './EffectsBubbles.vue';
import { ForwardSlots } from 'vue-forward-slots';
import { MqResponsive } from 'vue3-mq';

const props = withDefaults(
  defineProps<{
    effect?: number;
    effectRange?: number | null;
    appearance?: number;
    appearanceRange?: number | null;
    noAnimation?: boolean;
  }>(),
  { effectRange: null, appearanceRange: null, noAnimation: false }
);

const componentRef = ref(null);

const effects = [SdgBalloon, SdgFireworks, SdgRotationOne, EffectsBubbles];
const effect = props.effect !== undefined ? props.effect : Math.floor(Math.random() * (props.effectRange ?? effects.length));
const component = effects[effect] ?? effects[0];
const appearanceValue = ref(0);

onMounted(() => {
  const appearanceRange = props.appearanceRange ? props.appearanceRange : (componentRef.value || ({} as any)).appearanceRange || 1;
  appearanceValue.value = props.appearance ? props.appearance : Math.floor(Math.random() * appearanceRange);
});
</script>

<template>
  <div>
    <MqResponsive target="sm+">
      <ForwardSlots :slots="$slots">
        <Component ref="componentRef" :is="component" :appearance="appearanceValue" :noAnimation="props.noAnimation" />
      </ForwardSlots>
    </MqResponsive>
  </div>
</template>
